/* 
 * EIO Piljardivoistluse Graafika Praktikum
 * 16. detsember 2007
 * (C) Konstantin Tretjakov
 * (C) Dan Bogdanov
 */
#include "allegro.h"

BITMAP* buffer;
SAMPLE* snd;

void draw_animation () {
  clear_bitmap(screen);

  // Koordinaadid
  int x = 0, y = 0;
  bool mouse_up = true; 
  bool do_animating = true;

  // Animeerimistsykkel
  while (do_animating) {
    // Kustutame palli eelmisest positsioonist
    circlefill (buffer, x, y, 10, makecol (0, 0, 0));
    
    // Uus positsioon:
    x = mouse_x;
    y = mouse_y;

    // Kas peame valjuma?
    if (key[KEY_ESC]) {
      do_animating = false;
    }
   
    // Kas peame helinat tekitama?
    // (oigem oleks tegelikult kasutada mouse_callback funktsiooni)
    if (((mouse_b & 1) != 0) && mouse_up) {
         play_sample(snd, 255, 128, 1000, 0);
    }
    mouse_up = (mouse_b & 1) == 0;
    
    // Joonistame palli uues positsioonis
    circlefill (buffer, x, y, 10, makecol (255, 255, 255));
    textout(buffer, font, "Liigu hiirega. Klikk teeb haalt. ESC valjub.", 10, 10, makecol (255, 255, 255)); 
      blit(buffer, screen, 0, 0, 0, 0, 800, 600); 
    rest (25);
  }
  stop_sample(snd);
}


/* 
 * main, nagu ikka
 */
int main(int argc, char *argv[]) {
  allegro_init();
  install_keyboard();
  install_mouse();
  install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
  int bits = desktop_color_depth ();
  set_color_depth (bits);
  set_gfx_mode (GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0);
    buffer = create_bitmap(800, 600);
    clear_bitmap(buffer);
    snd = load_sample("cow.wav");
  draw_animation ();
  
  return 0;
}
END_OF_MAIN ()

