/* 
 * EIO Piljardivoistluse Graafika Praktikum
 * 16. detsember 2007
 * (C) Konstantin Tretjakov
 * (C) Dan Bogdanov
 */
#include "allegro.h"

void draw_animation () {
  clear_bitmap(screen);

  // Koordinaadid
  int x = 0, y = 0;
  bool do_animating = true;

  // Animeerimistsykkel
  while (do_animating) {
    // Kustutame palli eelmisest positsioonist
    circlefill (screen, x, y, 10, makecol (0, 0, 0));
    
    // Vaatame mida oli vajutatud ja liigutame palli
    if (key[KEY_UP]) {
      if (y > 10) y -= 5;
    }     
    if (key[KEY_LEFT]) {
      if (x > 10) x -= 5;
    }
    if (key[KEY_RIGHT]) {
      if (x < 789) x += 5;
    }
    if (key[KEY_DOWN]) {
      if (y < 589) y += 5;
    }
    if (key[KEY_ESC]) {
      do_animating = false;
    }
   
    // Joonistame palli uues positsioonis
    circlefill (screen, x, y, 10, makecol (255, 255, 255));
    textout(screen, font, "Liigu noolteklahvidega. ESC valjub.", 10, 10, makecol (255, 255, 255)); 
    rest (25);
  }
}


/* 
 * main, nagu ikka
 */
int main(int argc, char *argv[]) {
  allegro_init ();
  install_keyboard ();
  int bits = desktop_color_depth ();
  set_color_depth (bits);
  set_gfx_mode (GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0);

  draw_animation ();
  
  return 0;
}
END_OF_MAIN ()

